-----------------------------------------------------------------------------------------------
-- Client Lua Script for ItemPreviewImproved_MountTracker
-- Copyright (c) NCsoft. All rights reserved
-----------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- ItemPreviewImproved_MountTracker Module Definition
-----------------------------------------------------------------------------------------------
local ItemPreviewImproved_MountTracker = {} 
 
-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999


-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function ItemPreviewImproved_MountTracker:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function ItemPreviewImproved_MountTracker:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end

function ItemPreviewImproved_MountTracker:OnSave(eLevel)
	
	if (eLevel ~= GameLib.CodeEnumAddonSaveLevel.Account) then 
		return 
	end 

	local l,t,r,b = self.wndMain:GetAnchorOffsets()
	
	return {
		tPosition_Main = { l = l, t = t, r = r, b = b },
	}
	
end

function ItemPreviewImproved_MountTracker:OnRestore(eLevel,tSavedData) 
	
	if (eLevel ~= GameLib.CodeEnumAddonSaveLevel.Account) then 
		return 
	end 
	
	local tPosMain = tSavedData.tPosition_Main
	
	if tPosMain ~= nil then 
		self.wndMain:SetAnchorOffsets(tPosMain.l, tPosMain.t, tPosMain.r, tPosMain.b)
	end
	
end 

-----------------------------------------------------------------------------------------------
-- ItemPreviewImproved_MountTracker OnLoad
-----------------------------------------------------------------------------------------------
function ItemPreviewImproved_MountTracker:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("ItemPreviewImproved_MountTracker.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- ItemPreviewImproved_MountTracker OnDocLoaded
-----------------------------------------------------------------------------------------------
function ItemPreviewImproved_MountTracker:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "ItemPreviewImproved_MountTrackerForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)

		-- if the xmlDoc is no longer needed, you should set it to nil
		-- self.xmlDoc = nil
		
		-- Register handlers for events, slash commands and timer, etc.
		-- e.g. Apollo.RegisterEventHandler("KeyDown", "OnKeyDown", self)
		Apollo.RegisterSlashCommand("ipim", "OnItemPreviewImproved_MountTrackerOn", self)


		-- Do additional Addon initialization here
	end
end

-----------------------------------------------------------------------------------------------
-- ItemPreviewImproved_MountTracker Functions
-----------------------------------------------------------------------------------------------
-- Define general functions here

-- on SlashCommand "/ipim"
function ItemPreviewImproved_MountTracker:OnItemPreviewImproved_MountTrackerOn()
	local tMountList = AbilityBook.GetAbilitiesList(Spell.CodeEnumSpellTag.Mount) or {}
	self.wndMain:FindChild("txtMounts"):SetText("")
	
	for idx, tMountData in pairs(tMountList) do
		local tMountTierData = tMountData.tTiers[tMountData.nCurrentTier]
		local mountname = tMountData.strName
		
		if tMountTierData.bIsHoverboard == true then
			local mountid = tMountTierData.nPreviewCreatureId
			local hoverboardid = tMountTierData.nPreviewHoverboardItemDisplay
			local oldText = self.wndMain:FindChild("txtMounts"):GetText()
			local txtString = "Mount Name: " .. mountname .. " Mount ID: " .. mountid .. " Hoverboard ID: " .. hoverboardid .. "\n"
			self.wndMain:FindChild("txtMounts"):SetText(oldText .. txtString)
		else
			local mountid = tMountTierData.nPreviewCreatureId
			local oldText = self.wndMain:FindChild("txtMounts"):GetText()
			local txtString =  "Mount Name: " .. mountname .. " Mount ID: " .. mountid .. "\n"
			self.wndMain:FindChild("txtMounts"):SetText(oldText .. txtString)
		end
	end
	
	self.wndMain:Show(true)
end

function ItemPreviewImproved_MountTracker:OnCloseBtn()
	self.wndMain:Show(false)
end
-----------------------------------------------------------------------------------------------
-- ItemPreviewImproved_MountTracker Instance
-----------------------------------------------------------------------------------------------
local ItemPreviewImproved_MountTrackerInst = ItemPreviewImproved_MountTracker:new()
ItemPreviewImproved_MountTrackerInst:Init()
